akulsareen's blog

Hi Codeforces community,

Computer Science Association & Association of Computing Machinery, BITS PILANI, Pilani Campus presents you their flagship contest, "International Coding League 2018". It is being organised as a part of our annual technical fest, Apogee.

The contest will be External rated contest and will be of 2.5 hours.

Contest Link : https://www.codechef.com/ICL2018

Start Time : 20:00 IST, 27th February' 2017

Prizes: Worth Rs 20000 (10k + 6k + 4k) for top 3 Indian winners.

Also top 2 Global winners and top 2 Indian winners will get 250 laddus each.

The contest consists of 5 algorithmic problems of varying difficulty. The problems have been set such that even beginners can attempt a few problems and even the best coders find tough job ahead at the hard ones. It is advised to read every problem in the contest. The detailed editorials of all the problems with the Setter's & Tester's code will be uploaded immediately after the contest so that you may benefit from it.

The setting and testing panel includes flatline, likecs, diveshuttam, RoronoaXoro and vibhavoswal. I would also like to thank arjunarul from Codechef team for going through the problems and improving the statements as well.

To participate in the contest, you just need a Codechef handle and then just click on the link mentioned above for participating for the contest.

I hope you enjoy the contest and Happy Coding :)

You can find the link of last year contest here

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Update: The contest ranking is similar to ACM ICPC style and penalty for wrong submission has been set to 10 minutes.

Less than half hour to go for the contest.

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Update for Codechef team: Top 5 Global and Top 5 Indians get 250 laddus.

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Contest has started. Best of luck to everyone.

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

You can find the intended solutions here. I will be uploading the short editorials in a while. Detailed ones will be put up on codechef discuss forum by tomorrow. Hope you all enjoyed the contest.

Any feedback regarding the clarity of problems, time limits, test data being weak/strong etc?

»
6 years ago, # |
  Vote: I like it +16 Vote: I do not like it

Short Editorial of first 4 problems:

Problem 1 — Matrix Game Greedy solution applies and Matrix has no rolw in the problem. Just consider the numbers and at each moment of time every person tries to take the largest available number. Find the sum they can accumulate after this process and print answer accordingly.

Problem 2 — Stingy Strings Again greedy solution applies in the sense that we replace all occurences of a given character by its corresponding number or replace none of them. Next part is to modify the cost function as "length — 2*(count of numbers) + (sum of numbers)/k". Using this, we can say that we replace only those ccharacters with numbers whose value is greater than or equal to 2*k.

Problem 3 — Maze love

Let number of steps taken in each direction be N, S, E, W. So we have following equations:

N — S = m, E — W = n, Na + Sb + Ec + Wd = P

Replace S, W in last equation, we get N * A + E * B = C, where A = a + b, B = c + d, C = P + mb + nd

The other constraints are N, S, E, W are integers and N >= m, S >= 0 and E >= n, W>= 0.

Solution exists when gcd(A, B) divides C. After this check, we simply brute force over the possible values of N and update answer (i.e. minimum value of N+S+E+W) if present.

Problem 4 — Replace and Substring queries.

Idea is to find the number of substrings with given mask in string B easily. For this, we fix a particular index and find the first point of occurrence of every character on the right and add the corresponding contribution to the mask. For example- In "aabbbbdac" for index 1, "a" occurs at "1", "b" occurs at "3", "d" occurs at "7" and "c" occurs at "9". So number of substring with one endpoint at 1 and having mask 1 are 2, mask 3 are 3, mask 11 are 2 and mask 15 is 1.

One this initial computation is done, we try to handle the queries and updates. For query on string "a", we just need to find the mask of the substring a[l:r] and this requires to compute if a particular character occurs in a range. With updates on string "a", this can be easily handled using fenwick tree or segment tree.

To handle updates on string "b", idea is to first remove contribution of every substring which contains the xth character and then add the contribution back. For finding number of mask of substrings with contain xth character, we see the substring can either end at x, start at x or contain x in the middle. The first 2 are easy to calculate and are similar to the construction by finding first occurrence to the left and right of index x. For the substring which contain "x" in the middle we can visualise them as 2 parts, left and right and their mask being the "OR" of the left and right mask. Thus doing this OR convolution of the left and right masks in naive manner i.e. O(ALPHA**2) we can find their contribution too.

Complexity of precomputation is O(m * ALPHA * log m) and query and update on string "a" is O(ALPHA * logn) and O(log n) while update on string "b" is O(ALPHA * log m + ALPHA**2).

  • »
    »
    6 years ago, # ^ |
      Vote: I like it +10 Vote: I do not like it

    Can maze love be solved in logarithmic time per query.??
    It looks so but I couldnt formalise.Can anyone exlpain.

    • »
      »
      »
      6 years ago, # ^ |
        Vote: I like it +8 Vote: I do not like it

      Yes, it can solved using the idea of general solution for extended euclid algorithm and then using idea of critical points.

      Idea is: Consider the general solution for euclid algorithm, and find ranges of parameter "t" in it for which the inequalities on N and E hold. After finding the ranges of "t", we can change the optimisation function (N+S+E+W) in terms of "t", where "x0, y0, n, m" (inital solution for euclid algorithm, destination coordinates) are constant and don't depend on "t". So we need to minimise a line function of form "A+Bt" within some interval. This is normal calculus.

      • »
        »
        »
        »
        6 years ago, # ^ |
          Vote: I like it 0 Vote: I do not like it

        Could you please elaborate what form of general solution are you talking about. Also if you could tell me what to study in order to understand this (links or terms), that would be very helpful. Thanks :)

  • »
    »
    6 years ago, # ^ |
    Rev. 3   Vote: I like it 0 Vote: I do not like it

    1804 maze love,

    Making olivia reach to destination (X, Y) using X + Y steps and then solving for positive integral solutions to (n + s)x + (w + e)y = P - n * Y - e * X (n,s,e,w are costs along north, south, east, west repectively).

    Final answer must be X + Y + 2 * (x + y)

    IDEA: Greedily reaching to destination using X + Y steps and then looping by going north/south, west/east to make energy reduce to zero. If any steps are involved other than X+Y to reach initially then I can shift the moves to perform it after I reach (X, Y).

    Can somebody point mistake in it, I'm getting WA.

  • »
    »
    6 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Can you explain the update part on string B more clearly with an example

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Is the expected solution of Raid Systems O(log(y) * log(n)) per query of type 2? I barely got AC using this.

  • »
    »
    6 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    My solution uses 3ceil(log2(n)) precomputation and handles every query in O(logn)

»
6 years ago, # |
Rev. 2   Vote: I like it 0 Vote: I do not like it

Short explanation for last problem: Raid Systems

The first idea of the problem is to see that files on xth hard disk can be retrieved using files on hard disk 1. The file indices differ by exactly (x-1). For example, if at any moment of time, hard disk 1 has files f1, f2, f5 when n = 5, then hard disk 2 has files f(1+2-1), f(3+2-1), f(5+2-1) i.e. f2, and f3 (f7 is discarding). See the table to convince regarding this observation. Thus, the queries of both type can be handled very easily using binary search only provided we are able to find the files in sorted order on hard disk 1 on any day.

Next thing is to notice is that the pattern of files being stored on hard disk 1 will repeat after some time, to be precise after 2**(ceil(log2(n)). Draw a table for n = 8 and n = 5 to get view of it. Next observation is that total number of files we require for all possible days is bounded by 3**ceil(log2(n)). For example: Consider n = 4

0: f1

1: f1, f2, f3, f4

2: f1, f3

3: f1, f2

4: same as 0 i.e. pattern repeats.

The total number of files stored i.e. slots used is (1 + 4 + 2 + 2) = 9, 3**2. You can see this thing for any general n. Complete the table for n=5 and observe the same. Now, we just need to come up with a 3**(ceil(log2(n)) generation algorithm, which gives us the files in sorted order on any day. The memory complexity will also be the same. Many constructive algorithms can exist and you can try to find your own. My solution uses just one of my finding, idea is again similar to binary search i.e. can be divide the files (in sorted order) in half, calculate the files on left side and use it to calculate the files on right side. Basically, I mean to say that if a particular bit is set in "y" and we calculate the lower half files, then the upper half files are basically the mirror image on the lower half files. You can check my "gen" function in the solution code for details. Code

»
6 years ago, # |
  Vote: I like it +13 Vote: I do not like it

Good Problemset. I particularly liked the problem "Replace and Substring queries"

»
6 years ago, # |
Rev. 2   Vote: I like it 0 Vote: I do not like it

Sorry for the delays, the editorials are given in below links:

  1. ICL1801
  2. ICL1802
  3. ICL1803
  4. ICL1804
  5. ICL1805